;-----------------------------------------------------------------------------
; DOS.INC - Some extract from dgVoodooConfig and DOS.H for the assembly
;
; Copyright (C) 2003 Dege
;
; This library is free software; you can redistribute it and/or
; modify it under the terms of the GNU Lesser General Public
; License as published by the Free Software Foundation; either
; version 2.1 of the License, or (at your option) any later version.
;
; This library is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
; Lesser General Public License for more details.
;
; You should have received a copy of the GNU Lesser General Public
; License along with this library; if not, write to the Free Software
; Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
;-----------------------------------------------------------------------------

;------------------------------------------------------------------------------------------
; Defincik, amelyek a Dos-os s Windows-os DLL-ben is kellenek
;------------------------------------------------------------------------------------------

;------------------------------------------------------------------------------------------
;A wrapper konfigurcijt ler struktra
dgVoodooConfig  STRUC

ProductVersion  DW	?
GlideVersion    DW	?
TexMemSize      DD      ?
Flags           DD      ?
Gamma           DD      ?
Version         DD      ?
VideoMemSize_c  DD      ?
VideoRefreshFreq DD     ?
dxres           DW      ?
dyres           DW      ?
dispdev         DW      ?
dispdriver      DW      ?
refreshRate		DD		?
flags2			DD		?
dosTimerBoostPeriod DW	?
alphaCKRefValue DB		?
language		DB		?
rendererApi		DB		?
reserved_c      DB      3 DUP(?)

dgVoodooConfig  ENDS

;------------------------------------------------------------------------------------------
; Alaprtelmezett rtkek a config struktra mezihez
MAXTEXNUM_D     EQU     2048            ;Textrk max. szma
TEXTUREMEMSIZE  EQU     4*1024*1024     ;Voodoo-textramem mrete

;------------------------------------------------------------------------------------------
; Konstansok a konfig struktra flagjeihez
CFG_WBUFFER				EQU		1h			;W-buffert mindig Z-bufferen keresztl emull
CFG_RELYONDRIVERFLAGS	EQU		CFG_WBUFFER
CFG_WINDOWED			EQU		2h			;Ablakos md
CFG_DISPMODE32BIT		EQU		4h			;32 bites videomd
CFG_SETREFRESHRATE		EQU		8h			;A frisstsi freq-t az alkalmazs
											;	lltja be (egybknt az akt. freq)
CFG_PERFECTTEXMEM		EQU		10h			;	Tkletes textramemria-emulci
CFG_WBUFFERMETHODISFORCED EQU	80h			;	A W-bufferels mdszere knyszertett:
											;		- CFG_WBUFFER flag set: mindig valdi w-bufferels
											;		- CFG_WBUFFER flag not set: mindig emullt w-bufferels
											;						vagy a W-bufferels mdszere detektlt, ekkor
											;		- CFG_RELYONDRIVERFLAGS set: a driver ltal a W-bufferels tmogatsra
											;								 visszaadott flag alapjn dnt
CFG_VESAENABLE          EQU     100h        ;Beptett VESA-tmogats engedlyezve
CFG_SETMOUSEFOCUS       EQU     200h        ;Egrfkusz az alkalmazsnl
CFG_SUPPORTMODE13H      EQU     400h        ;320x200x256 VGA-md tmogatsa
CFG_TEXTURES32BIT       EQU     800h        ;mindig 32 bites textrk
CFG_TEXTURES16BIT       EQU     1000h       ;mindig 16 bites textrk
CFG_TEXTURERELOAD       EQU     2000h       ;Textrk jratltse, ha kell
CFG_GRABENABLE          EQU     4000h       ;Kpernylops engedlyezve
CFG_GRABCLIPBOARD       EQU     8000h       ;Kplops a vglapra
CFG_CKMGEFORCE          EQU     10000h      ;Colorkeying GeForce-ra (2-es mdszer)
CFG_TOMBRAIDER          EQU     20000h      ;TR1 rnykhiba-javts
CFG_HUNGARIAN           EQU     40000h      ;A nyelv magyar
CFG_HWLFBCACHING        EQU     80000h      ;Hardveres gyorstpufferek az LFB-hez
CFG_LFBREALVOODOO       EQU     100000h     ;Kzelebb az igazi hardverhez
CFG_TRIPLEBUFFER        EQU     200000h     ;Mindig triplapufferels
CFG_ACTIVEBACKGROUND    EQU     400000h     ;A httren is aktv a DOS-os prg
CFG_LFBFASTUNMATCHWRITE EQU     800000h     ;Gyorsrs a nem egyez LFB formtumokhoz
CFG_CTRLALT             EQU     1000000h    ;Egrfkusz elengedse Ctrl-Alt-ra
CFG_VSYNC               EQU     2000000h    ;Fggleges visszafutst mindig megvrni
CFG_NTVDDMODE           EQU     4000000h    ;a wrapper VDD-mdban mkdik (XP-hez)
CFG_DISABLEMIPMAPPING   EQU     8000000h    ;Mipmapping tiltsa
CFG_ENABLEGAMMARAMP     EQU     10000000h   ;Glide-gammaramp engedlyezse
CFG_ENABLEHWVBUFFER     EQU     20000000h   ;Hardveres vertex pufferek hasznlata
CFG_BILINEARFILTER      EQU     40000000h   ;Mindig bilineris szrs a textrkhoz
CFG_CLIPPINGBYD3D       EQU     80000000h   ;Vgs a Direct3D-n keresztl

CFG2_CLOSESTREFRESHFREQ EQU     1h
CFG_FORCECLIPOPF        EQU     2h          ;CLI/POPF megfelel kezelse - rejtett opci
CFG_LFBRESCALECHANGESONLY EQU   4h          ;eltr felbontsok esetn csak a vltozsok tmretezse,
                                            ; s nem az egsz kp (gyorsrst ignyel) - rejtett opci
CFG_LFBFORCEFASTWRITE   EQU   8h            ;Gyorsrs hasznlata egyez formtumokhoz is - rejtett opci
CFG_YMIRROR             EQU   10h           ;Kperny fggleges tkrzse (orig-tesztekhez) - rejtett opci
CFG_FORCETRILINEARMIPMAPS EQU   20h         ;Trilineris mipmapping knyszertse - rejtett opci
CFG_PREFERTMUWIFPOSSIBLE  EQU   40h         ;tbls kd, z-buffer s TMUDIFFW hint esetn a tmu w-t
CFG_LFBALWAYSFLUSHWRITES  EQU	80h	    ;A rgi lfb-unlock dude-mdja: mindig kirja a vltozsokat
					    ;(nem cache-el) (kompatibilitsi s teszt-opci, rejtett)
CFG_DEPTHEQUALTOCOLOR	EQU	100h	    ;A kppuffer s a mlysgi puffer bitmlysge legyen mindig egyenl								    ;(kompatibilitsi s teszt-opci, rejtett)
CFG_DISABLELFBREAD	EQU	200h	    ;LFB elrsnek tiltsa olvassra
CFG_DISABLELFBWRITE	EQU	400h	    ;LFB elrsnek tiltsa rsra
CFG_AUTOGENERATEMIPMAPS	EQU	800h	    ;A hinyz mipmap-szintek automatikus generlsa
CFG_LFBNOMATCHINGFORMATS  EQU	1000h	    ;Az LFB-formtumok mindig klnbznek tekintendk - rejtett opci
CFG_ALWAYSINDEXEDPRIMS	EQU	2000h		
CFG_HIDECONSOLE		EQU	4000h	    ;Konzol elrejtse (DOS)
CFG_LFBENABLETEXTURING	EQU	8000h
CFG_CFORMATAFFECTLFB	EQU	10000h
CFG_DISABLEVESAFLATLFB	EQU	20000h


;A konfig flagekben lev bitmezk rtkei
CFG_CKMAUTOMATIC	EQU	00
CFG_CKMALPHABASED	EQU	01
CFG_CKMNATIVE		EQU	02
CFG_CKMNATIVETNT	EQU	03

;------------------------------------------------------------------------------------------
;Az egyes platformok kdjai
PLATFORM_WINDOWS          EQU   0
PLATFORM_DOSWIN9X         EQU   1
PLATFORM_DOSWINNT         EQU   2

;------------------------------------------------------------------------------------------
; Az aktulis videmd s annak pixelformtuma (VESA-hoz)

dgVoodooModeInfo        STRUC

modeIndex				DD		?
ModeNumber              DW      ?
XRes                    DW      ?
YRes                    DW      ?
BitPP                   DB      ?
RedSize                 DB      ?
RedPos                  DB      ?
GreenSize               DB      ?
GreenPos                DB      ?
BlueSize                DB      ?
BluePos                 DB      ?
RsvSize                 DB      ?
RsvPos                  DB      ?
                        DB      ?

dgVoodooModeInfo        ENDS

;------------------------------------------------------------------------------------------
; Egrkurzor-inf: jelenleg hasznlaton kvli */
MouseInfo       STRUC

mi_x            DD      ?
mi_y            DD      ?
brecttop_x      DD      ?
brecttop_y      DD      ?
brectbottom_x   DD      ?
brectbottom_y   DD      ?

MouseInfo       ENDS

;------------------------------------------------------------------------------------------

EXEBUFFSIZE     EQU     ((32*1024)/4)
FUNCDATASIZE    EQU     1536*1024

KFLAG_INKERNEL  	EQU     1h
KFLAG_VMWINDOWED	EQU	2h
KFLAG_SCREENSHOT        EQU     4h
KFLAG_GLIDEACTIVE       EQU     8h
KFLAG_SERVERWORKING	EQU	20h
KFLAG_CTRLALT		EQU	80h
KFLAG_PALETTECHANGED	EQU	100h
KFLAG_VESAFRESHDISABLED EQU	200h

AREAID_COMMAREA                 EQU     1
AREAID_REGSTRUCTURE_GLIDE211    EQU     2
AREAID_REGSTRUCTURE_GLIDE243    EQU     3

; A kommunikcis terlet felptse (ez van az osztott memriaterleten)
CommArea        STRUC

areaId          DD      ?
kernelflag      DD      ?
ExeCodeIndex    DD      ?
FDPtr           DD      ?
progname        DB      128 DUP(?)
WinOldApHWND    DD      ?
VESAPalette     DD      256 DUP(?)
VESASession     DB      ?
VGAStateRegister3DA     DB      ?
VGARAMDACSize   DB      ?
                DB      ?
VideoMemory     DD      ?
videoMemoryClient DD	?
BytesPerScanLine DD     ?
DisplayOffset   DD      ?
actmodeinfo     dgVoodooModeInfo <>
vesaModeinfo    dgVoodooModeInfo <>
;mouseinfo       MouseInfo <>

ExeCodes        DD      EXEBUFFSIZE DUP(?)
FuncData        DB      FUNCDATASIZE DUP(?)

;LFB		DB	0 DUP(?)

CommArea        ENDS

;------------------------------------------------------------------------------------------
ServerRegInfo   STRUC

areaId_regs     DD      ?
workerthread_   DD      ?
commaptr        DD      ?
VideoMemSize    DD      ?
ConfigPtr       DD      ?
ErrorCode       DD      ?

ServerRegInfo   ENDS


;------------------------------------------------------------------------------------------
; Az egyes Glide-fggvnyek kdjai

GRGLIDEINIT                     EQU             0
GRSSTWINOPEN                    EQU             1
GRSSTWINCLOSE                   EQU             2
GRGLIDESHUTDOWN                 EQU             3

GRBUFFERCLEAR                   EQU             4
GRBUFFERSWAP                    EQU             5

GUDRAWTRIANGLEWITHCLIP          EQU             6
GUAADRAWTRIANGLEWITHCLIP        EQU             7
GUDRAWPOLYGONVERTEXLISTWITHCLIP EQU             8
GRDRAWTRIANGLE                  EQU             9
GRDRAWPOLYGONVERTEXLIST         EQU             10
GRAADRAWPOLYGON                 EQU             11
GRAADRAWPOLYGONVERTEXLIST       EQU             12
GRAADRAWTRIANGLE                EQU             13
GRDRAWPLANARPOLYGON             EQU             14
GRDRAWPLANARPOLYGONVERTEXLIST   EQU             15
GRDRAWPOLYGON                   EQU             16
GRAADRAWLINE                    EQU             17
GRDRAWLINE                      EQU             18
GRAADRAWPOINT                   EQU             19
GRDRAWPOINT                     EQU             20


GRTEXDOWNLOADMIPMAP             EQU             21
GRTEXDOWNLOADMIPMAPLEVEL        EQU             22
GRTEXDOWNLOADMIPMAPLEVELPARTIAL EQU             23
GRTEXDOWNLOADTABLE              EQU             24
GRTEXDOWNLOADTABLEPARTIAL       EQU             25
GRTEXNCCTABLE                   EQU             26
GRTEXSOURCE                     EQU             27
GRTEXMIPMAPMODE                 EQU             28
GRTEXCOMBINE                    EQU             29
GRTEXFILTERMODE                 EQU             30
GRTEXCLAMPMODE                  EQU             31
GRTEXLODBIASVALUE               EQU             32
GRTEXMULTIBASE                  EQU             33
GRTEXMULTIBASEADDRESS           EQU             34

GUTEXALLOCATEMEMORY             EQU             35
GUTEXCHANGEATTRIBUTES           EQU             36
GUTEXCOMBINEFUNCTION            EQU             37
GUTEXDOWNLOADMIPMAP             EQU             38
GUTEXDOWNLOADMIPMAPLEVEL        EQU             39
GUTEXGETCURRENTMIPMAP           EQU             40
GUTEXGETMIPMAPINFO              EQU             41
GUTEXMEMQUERYAVAIL              EQU             42
GUTEXMEMRESET                   EQU             43
GUTEXSOURCE                     EQU             44
GU3DFGETINFO                    EQU             45
GU3DFLOAD                       EQU             46
GLIDEGETUTEXTURESIZE            EQU             47

GRCOLORCOMBINE                  EQU             48
GUCOLORCOMBINEFUNCTION          EQU             49
GRCONSTANTCOLORVALUE4           EQU             50
GRCOLORMASK                     EQU             51
GRCONSTANTCOLORVALUE            EQU             52
                                        
GRALPHABLENDFUNCTION            EQU             53
GRALPHACOMBINE                  EQU             54
GRALPHACONTROLSITRGBLIGHTING	EQU				55
GUALPHASOURCE                   EQU             56
GRALPHATESTFUNCTION             EQU             57
GRALPHATESTREFERENCEVALUE       EQU             58

GRFOGCOLORVALUE                 EQU             59
GRFOGMODE                       EQU             60
GRFOGTABLE                      EQU             61
GLIDEGETINDTOWTABLE             EQU             62
GUFOGTABLEINDEXTOW              EQU             63
GUFOGGENERATEEXP                EQU             64
GUFOGGENERATEEXP2               EQU             65
GUFOGGENERATELINEAR             EQU             66

GRRENDERBUFFER                  EQU             67
GRSSTORIGIN                     EQU             68
GRCLIPWINDOW                    EQU             69
GRCULLMODE                      EQU             70
GRDISABLEALLEFFECTS             EQU             71
GRDITHERMODE                    EQU             72
GRGAMMACORRECTIONVALUE          EQU             73
GRGLIDEGETSTATE                 EQU             74
GRGLIDESETSTATE                 EQU             75
GRHINTS                         EQU             76

GRSSTSCREENWIDTH                EQU             77
GRSSTSCREENHEIGHT               EQU             78
GRSSTSTATUS                     EQU             79
GRSSTVIDEOLINE                  EQU             80
GRSSTVRETRACEON                 EQU             81
GRSSTCONTROLMODE                EQU             82
GRBUFFERNUMPENDING              EQU             83
GRRESETTRISTATS                 EQU             84
GRTRISTATS                      EQU             85
                                        
GRDEPTHBUFFERMODE               EQU             86
GRDEPTHBUFFERFUNCTION           EQU             87
GRDEPTHMASK                     EQU             88
GRLFBCONSTANTALPHA              EQU             89
GRLFBREADREGION                 EQU             90
GRLFBWRITEREGION                EQU             91
GRDEPTHBIASLEVEL                EQU             92
GLIDEGETCONVBUFFXRES            EQU             93

GRCHROMAKEYMODE                 EQU             94
GRCHROMAKEYVALUE                EQU             95

GRLFBLOCK                       EQU             96
GRLFBUNLOCK                     EQU             97
GRLFBWRITECOLORFORMAT           EQU             98
GRLFBWRITECOLORSWIZZLE          EQU             99
GLIDESETUPLFBDOSBUFFERS         EQU             100

;Glide1-fggvnyek
GRSSTOPEN                       EQU             101
GRLFBBYPASSMODE                 EQU             102
GRLFBORIGIN                     EQU             103
GRLFBWRITEMODE                  EQU             104
GRLFBBEGIN                      EQU             105
GRLFBEND                        EQU             106
GRLFBGETREADPTR                 EQU             107
GRLFBGETWRITEPTR                EQU             108
GUFBREADREGION                  EQU             109
GUFBWRITEREGION                 EQU             110


;VESA-fggvnyek
VESASETVBEMODE                  EQU             111
VESAUNSETVBEMODE                EQU             112
VESAFRESH                       EQU             113

;Ezeket a fggvnyeket a kernelmodul hivja
DGVOODOOCLIENTCRASHED           EQU             114
DGVOODOONEWCLIENTREGISTERING    EQU             115

;Egyb fggvnyek
DGVOODOOGETCONFIG               EQU             116
DGVOODOORELEASEFOCUS            EQU             117

GLIDEINSTALLMOUSE				EQU				118
GLIDEUNINSTALLMOUSE				EQU				119
GLIDEISMOUSEINSTALLED			EQU				120

VESAGETXRES						EQU				121
VESAGETYRES						EQU				122

PORTLOG_IN						EQU				123
PORTLOG_OUT						EQU				124

GLIDEENDITEM                    EQU             0FFFFFFFFh
